<?php

namespace MixerApi\ExceptionRender\Test\TestCase;

use Cake\TestSuite\TestCase;
use MixerApi\ExceptionRender\EntityValidationListener;
use MixerApi\ExceptionRender\ValidationException;
use MixerApi\ExceptionRender\Test\App\Model\Entity\Actor;
use MixerApi\ExceptionRender\Test\App\Model\Table\ActorsTable;

class EntityValidationTest extends TestCase
{
    /**
     * @var string[]
     */
    public $fixtures = [
        'plugin.MixerApi/ExceptionRender.Actors',
    ];

    public function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        static::setAppNamespace('MixerApi\ExceptionRender\Test\App');
    }

    public function test_validation()
    {
        new EntityValidationListener();

        $actorsTable = new ActorsTable();
        $actor = $actorsTable->patchEntity($actorsTable->newEmptyEntity(), [
            'first_name' => 'First',
            'last_name' => 'last'
        ]);

        $this->assertInstanceOf(Actor::class, $actor);
    }

    public function test_validation_exception()
    {
        $this->expectException(ValidationException::class);

        new EntityValidationListener();

        $actorsTable = new ActorsTable();
        $actorsTable->patchEntity($actorsTable->newEmptyEntity(), [
            'first_name' => '',
            'last_name' => ''
        ]);
    }
}
